#ifndef __DSP_instructions_h
#define __DSP_instructions_h

/* move.l #value,r0 */
#define once_move_long_to_r0(value)              	once_execute_native_instruction3(0xe418,(word)(value&0xffff),(word)(value>>16))

/* move.l #value,n */
#define once_move_long_to_n(value)               	once_execute_native_instruction3(0xe41e,(word)(value&0xffff),(word)(value>>16))

/* bfclr #value,x:(r0) */
#define once_bfclr_at_r0(value)                  	once_execute_native_instruction2(0x8040,value)

/* bfclr #value,x:(r0+n) */
#define once_bfclr_at_r0_disp(value,disp)        	once_execute_native_instruction3(0x8044,disp,value)

/* bfset #value,x:(r0+n) */
#define once_bfset_at_r0_disp(value,disp)        	once_execute_native_instruction3(0x8244,disp,value)

/* move #value,y0 */
#define once_move_value_to_y0(value)             	once_execute_native_instruction2(0x8745,value)

/* move #value,pc */
#define once_move_value_to_pc(value)             	once_execute_native_instruction3(0xE71E,(word)(value&0xffff),(word)(value>>16))

/* move pc,r4 */
#define once_move_pc_to_r4()                     	once_execute_native_instruction1(0xE716)

/* move x:(r0),y0 */
#define once_move_at_r0_y0()                     	once_execute_native_instruction1(0xF514)

/* move y0,x:(r0) */
#define once_move_y0_at_r0()                     	once_execute_native_instruction1(0xd514)

/* move y1,x:(r0) */
#define once_move_y1_at_r0()                     	once_execute_native_instruction1(0xd714)

/* move.l r4,y */
#define once_move_r4_to_y()                      	once_execute_native_instruction1(0xe764)

/* move.l r3,y */
#define once_move_r3_to_y()                      	once_execute_native_instruction1(0xe763)

/* move.l r2,y */
#define once_move_r2_to_y()                      	once_execute_native_instruction1(0xe762)

/* bfclr <mask>,omr */
#define once_bfclr_omr(mask)                     	once_execute_native_instruction2(0x815c,mask)

/* move.w omr,y0 */
#define once_move_omr_to_y0()                    	once_execute_native_instruction1(0x851c)

/* moveu.w y0,omr */  /* added to make it test something here */
#define once_move_y0_to_omr()                           once_execute_native_instruction1(0x8C85)

/* move.w y0,p:(r0)+ */
#define once_move_y0_at_pr0_inc()                	once_execute_native_instruction1(0x8560)

/* move.w p:(r0)+,y0 */
#define once_move_at_pr0_inc_to_y0()             	once_execute_native_instruction1(0x8568)

/* move.w p:(r2)+,y0 */
#define once_move_at_pr2_inc_to_y0()             	once_execute_native_instruction1(0x856A)

/* move.l #value,r2 */
#define once_move_long_to_r2(value)              	once_execute_native_instruction3(0xe41A,(word)(value&0xffff),(word)(value>>16))

/* move y0,x:(r2) */
#define once_move_y0_at_r2()                     	once_execute_native_instruction1(0xd516)

/* move.w x:(r2),Y0 */
#define once_move_at_r2_to_y0()                  	once_execute_native_instruction1(0xF516)

/* move.w x:(R2+<disp>),Y0 */
#define once_move_at_r2_disp_to_y0(disp)         	once_execute_native_instruction2(0xF542,disp)

/* move.w #<value>,x:(R2) */
#define once_move_value_at_r2(value)             	once_execute_native_instruction2(0x8642,value)

/* move.w #<value>,x:(R2+<disp>) */
#define once_move_value_at_r2_disp(value,disp)   	once_execute_native_instruction3(0x8646,value,disp)

/* move.w #<value>,x:(R3+<disp>) */
#define once_move_value_at_r3_disp(value,disp)   	once_execute_native_instruction3(0x8647,value,disp)

/* move.l #value,r3 */
#define once_move_long_to_r3(value)              	once_execute_native_instruction3(0xE41B,(word)(value&0xffff),(word)(value>>16))

/* move.w y0,p:(r3)+ */
#define once_move_y0_at_pr3_inc()                	once_execute_native_instruction1(0x8563)

/* move.w y0,x:(r3) */
#define once_move_y0_at_r3()                     	once_execute_native_instruction1(0xD503)

/* nop */
#define once_nop()                               	once_execute_native_instruction1(0xe700)

/* move.w y0,x:(r0)+ */
#define once_move_y0_at_r0_inc()                 	once_execute_native_instruction1(0xd500)

/* move.w x:(r0)+,y0 */
#define once_move_at_r0_inc_to_y0()              	once_execute_native_instruction1(0xf500)

#endif