/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : PE_Timer.C
**     Project   : self_JTAG
**     Processor : MC56F8006_32_LQFP
**     Component : PE_Timer
**     Version   : Driver 01.03
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 8/6/2010, 10:10 PM
**     Abstract  :
**         This module "PE_Timer" implements internal methods and definitions
**         used by beans working with timers.
**     Settings  :
**     Contents  :
**         No public methods
**
**     Copyright : 1997 - 2009 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

/* MODULE PE_Timer. */

#include "PE_Timer.h"

typedef dword UINT32;

typedef union {
  UINT32 val;
  struct {
    word lo16,hi16;
  } s;
} OP_UINT32;

typedef struct {
  word dummy;
  word midlo16,midhi16;
} M_UINT32;

typedef struct {
  UINT32 lo32, hi32;
} UINT64;

typedef union {
  UINT64 val;
  M_UINT32 m; 
} OP_UINT64;

/*
** ===================================================================
**     Method      :  PE_Timer_LngMul (component PE_Timer)
**
**     Description :
**         32bits number x 32bits number -> 64bits number. The method is 
**         called automatically as a part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
void PE_Timer_LngMul(dword va1, dword va2, dlong *var)
{
  OP_UINT32 *va = (OP_UINT32*)&va1;
  OP_UINT32 *vb = (OP_UINT32*)&va2;
  OP_UINT64 *vr = (OP_UINT64*)var;
  
  vr->val.hi32 = 0UL;
  vr->val.lo32 = ((UINT32)va->s.lo16)*((UINT32)vb->s.lo16);
  {
    OP_UINT32 tmp;
    OP_UINT32 register tmpx;
    
    tmp.val = ((UINT32)va->s.lo16)*((UINT32)vb->s.hi16);

    tmpx.s.lo16 = vr->m.midlo16;
    tmpx.s.hi16 = vr->m.midhi16;
    tmpx.val += (UINT32)tmp.s.lo16;
    vr->m.midlo16 = tmpx.s.lo16;
    vr->m.midhi16 = tmpx.s.hi16;

    vr->val.hi32 += (UINT32)tmp.s.hi16;
  }
  {
    OP_UINT32 tmp;
    OP_UINT32 register tmpx;
    
    tmp.val = ((UINT32)va->s.hi16)*((UINT32)vb->s.lo16);

    tmpx.s.lo16 = vr->m.midlo16;
    tmpx.s.hi16 = vr->m.midhi16;
    tmpx.val += (UINT32)tmp.s.lo16;
    vr->m.midlo16 = tmpx.s.lo16;
    vr->m.midhi16 = tmpx.s.hi16;

    vr->val.hi32 += (UINT32)tmp.s.hi16;
  }
  vr->val.hi32 += ((UINT32)va->s.hi16)*((UINT32)vb->s.hi16);
}

/*
** ===================================================================
**     Method      :  PE_Timer_LngHi4 (component PE_Timer)
**
**     Description :
**         64bits number / 2^40 -> 16bits number. The method is called 
**         automatically as a part of several internal methods.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/
bool PE_Timer_LngHi4(dword Low, dword High, word *Out) 
{
  if ((High >> 16) == 0) {
    if ((Low & 0x80000000UL) != 0) {
      if (High < 0xFFFF) {
        *Out = ((word)High)+1;
        return FALSE;
      }  
    }  
    else { 
      *Out = (word)High;
      return FALSE;
    }
  }
  *Out = (word)High;
  return TRUE;
}

/* END PE_Timer. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 3.00 [04.35]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
