/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : TI1.H
**     Project   : self_JTAG
**     Processor : MC56F8006_32_LQFP
**     Component : TimerInt
**     Version   : Component 02.157, Driver 02.02, CPU db: 3.00.188
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 8/6/2010, 10:47 PM
**     Abstract  :
**         This bean "TimerInt" implements a periodic interrupt.
**         When the bean and its events are enabled, the "OnInterrupt"
**         event is called periodically with the period that you specify.
**         TimerInt supports also changing the period in runtime.
**         The source of periodic interrupt can be timer compare or reload
**         register or timer-overflow interrupt (of free running counter).
**     Settings  :
**         Timer name                  : RTC (8-bit)
**         Compare name                : RTCmod
**         Counter shared              : No
**
**         High speed mode
**             Prescaler               : divide-by-1
**             Clock                   : 16 Hz
**           Initial period/frequency
**             Xtal ticks              : 8192000
**             microseconds            : 1024000
**             milliseconds            : 1024
**             seconds                 : 1
**             seconds (real)          : 1.024
**             Hz                      : 1
**
**         Runtime setting             : period/frequency interval (continual setting)
**             ticks                   : 512000 to 130560000 ticks
**             microseconds            : 64000 to 16320000 microseconds
**             milliseconds            : 64 to 16320 milliseconds
**             seconds                 : 1 to 16 seconds
**             seconds (real)          : 0.064 to 16.32 seconds
**             Hz                      : 1 to 15 Hz
**
**         Initialization:
**              Timer                  : Disabled
**              Events                 : Enabled
**
**         Timer registers
**              Counter                : RTC_CNT   [62241]
**              Mode                   : RTC_SC    [62240]
**              Run                    : RTC_SC    [62240]
**              Prescaler              : RTC_SC    [62240]
**
**         Compare registers
**              Compare                : RTC_MOD   [62242]
**
**         Flip-flop registers
**     Contents  :
**         Enable      - byte TI1_Enable(void);
**         Disable     - byte TI1_Disable(void);
**         SetPeriodMS - byte TI1_SetPeriodMS(word Time);
**
**     Copyright : 1997 - 2009 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################*/

#ifndef __TI1
#define __TI1

/* MODULE TI1. */

/*Include shared modules, which are used for whole project*/
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include "PE_Timer.h"
#include "Cpu.h"

#define TI1_SPMS_MIN       64U         /* Lower bound of interval for parameter of method SetPeriodMS */
#define TI1_SPMS_MAX       16320U      /* Upper bound of interval for parameter of method SetPeriodMS */
/* Deprecated constants */
#define TI1_SPMSMin        64          /* Lower bound of interval for method SetPeriodMS */
#define TI1_SPMSMax        16320       /* Upper bound of interval for method SetPeriodMS */


byte TI1_Enable(void);
/*
** ===================================================================
**     Method      :  TI1_Enable (component TimerInt)
**
**     Description :
**         This method enables the component - it starts the timer.
**         Events may be generated (<DisableEvent>/<EnableEvent>).
**     Parameters  : None
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
** ===================================================================
*/

byte TI1_Disable(void);
/*
** ===================================================================
**     Method      :  TI1_Disable (component TimerInt)
**
**     Description :
**         This method disables the component - it stops the timer. No
**         events will be generated.
**     Parameters  : None
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
** ===================================================================
*/

byte TI1_SetPeriodMS(word Time);
/*
** ===================================================================
**     Method      :  TI1_SetPeriodMS (component TimerInt)
**
**     Description :
**         This method sets the new period of the generated events.
**         The period is expressed in miliseconds as a 16-bit
**         unsigned integer number.
**         This method is available only if the runtime setting type
**         'from interval' is selected in the Timing dialog box in
**         the Runtime setting area.
**     Parameters  :
**         NAME            - DESCRIPTION
**         Time            - Period to set [in miliseconds]
**                      (64 to 16320 milliseconds)
**     Returns     :
**         ---             - Error code, possible codes:
**                           ERR_OK - OK
**                           ERR_SPEED - This device does not work in
**                           the active speed mode
**                           ERR_MATH - Overflow during evaluation
**                           ERR_RANGE - Parameter out of range
** ===================================================================
*/

void TI1_Init(void);
/*
** ===================================================================
**     Method      :  TI1_Init (component TimerInt)
**
**     Description :
**         Initializes the associated peripheral(s) and the beans 
**         internal variables. The method is called automatically as a 
**         part of the application initialization code.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

void TI1_Interrupt(void);
/*
** ===================================================================
**     Method      :  TI1_Interrupt (component TimerInt)
**
**     Description :
**         The method services the interrupt of the selected peripheral(s)
**         and eventually invokes the beans event(s).
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

/* END TI1. */

#endif /* ifndef __TI1 */
/*
** ###################################################################
**
**     This file was created by Processor Expert 3.00 [04.35]
**     for the Freescale 56800 series of microcontrollers.
**
** ###################################################################
*/
