/** ###################################################################
**     Filename  : jtag_stuff.H
**     Project   : self_JTAG
**     Processor : MC56F8006_32_LQFP
**     Compiler  : Metrowerks DSP C Compiler
**     Date/Time : 7/5/2010, 1:37 PM
**     Contents  :
**         User source code
**
** ###################################################################*/

#ifndef __jtag_stuff_H
#define __jtag_stuff_H

/* MODULE jtag_stuff */

#include "DSP_instructions.h"

#define flash_base			  0xF400	/* base address of the Flash programming interface */
#define flash_clkdiv  		    0x28	/* flash clock divisor */
#define pram_exec_addr		0x008300	/* address of program RAM memory region used for algorithm execution */
#define dram_addr			0x000000	/* address of data RAM memory region used for algorithm data */

extern int systemRunState;
extern word clearedBits;

void loop();

int doIDCODE();
int doInitTap();
void SetLEDs(int val,word t);
void do_say_my_name();
void showBadness(int p,int q);
void showData(dword data,word bit_count);
void sparkleTime();
word check_for_patch(dword data_offset,word curWord);
void Cpu_DelayQuick(word us1);

dword select_core_tap(void);
dword select_master_tap(void);
void clearBits();
void gotoSelectDR();




void update_state();

dword jtag_data_shift(dword data, word bit_count);
void jtag_data_write16(word data);
void jtag_data_write8(word data);
void jtag_disconnect();
word jtag_data_read16(void);
word jtag_data_read8(void);
word jtag_instruction_exec(word instruction, word instr_len);
word jtag_measure_paths(void);

void once_ctrl_write(word data);
void once_execute_native_instruction1(word opcode);
void once_execute_native_instruction2(word opcode1, word opcode2);
void once_execute_native_instruction3(word opcode1, word opcode2,word opcode3);
dword once_instruction_exec(int instruction,int rw,int go,int ex);
char once_infect_other_badge();
char once_flash_erase();
char once_pgm_dload(const word *pgm, word pgm_size, dword pram_addr);
char once_set_hfmdiv();
void once_tx_upper_data(word data);
word once_ctrl_read();
word once_hfm_execute_command(byte command, dword address);
word once_read_base_addr();
word once_read_status_reg();
word once_rx_upper_data();



/////////////////////////
//                     //
//  Inlined Fimctions  //
//                     //
/////////////////////////

inline word pmem_read(register word *addr)
{
   register word data;

   asm(move.w p:(addr)+,data);
   return data;
}


//inline void pmem_write(register word* addr, register word data)
//{
//   asm(move.w  data,p:(addr)+n);
//}

/* END jtag_stuff */

#endif

